VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsRegistry"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "Beispiel\r\n1. hier wird die PreKey-Einstellung verwendet, da stSection nicht\r\n   mit 'HKEY_' beginnt\r\n   PreKey=""HKEY_CURRENT_USER\\Software\\HBSoft\\PEdit\\WindowSettings""\r\n   a = Getvalue(""frmPEdit"",""Left"",Default)\r\n2. hier wird der PreKey ignoriert (stSection fngt mit 'HKEY_' an)\r\n   PreKey=""HKEY_CURRENT_USER\\Software\\HBSoft\\Josko""\r\n   a=Getvalue(""HKEY_CURRENT_USER\\Software\\HBSoft\\PEdit\\WindowSettings\\frmPEdit"",""Left"",Default)\r\n3. hier wird die PreKey-Einstellung verwendet und der Parameter\r\n   stSection=""""\r\n   HKEY_CURRENT_USER\\Software\\hbsoft\\PEdit\\WindowSettings\\frmPEdit\r\n   a=Getvalue("""",""Left"",Default)\r\n"
Option Explicit
'Externe Module:  clsString
'                 clsError(m_Err)
'                 basVbUtils

'*********************** clsRegistry ************************
'**
'**
'** Ermglicht die Manipulation der Registry, wobei
'** allerdings nur String-Werte bearbeitet werden knnen.
'** Eventuell auftretende Fehler lassen sich mit dem
'** Property 'plError' abfragen. Die fehlerauslsende Methode
'** kann mit 'pstErrSource' ermittelt werden. Wenn die Klasse
'**  mit WhitEvents deklariert ist, wird der Event 'Error'
'** ausgelsst.
'**
'************************History****************************
'**
'** Datum / Author / Rechner
'** 16.09.97 RGrothaus    MIT01 : Erstrealisierung
'**
'** Update / Author / Rechner
'**
'************************Beispiel***************************
'** 1. hier wird die PreKey-Einstellung verwendet, da stSection nicht
'**    mit 'HKEY_' beginnt
'**    PreKey="HKEY_CURRENT_USER\Software\HBSoft\PEdit\WindowSettings"
'**    a = Getvalue("frmPEdit","Left",Default)
'** 2. hier wird der PreKey ignoriert (stSection fngt mit 'HKEY_' an)
'**    PreKey="HKEY_CURRENT_USER\Software\HBSoft\Josko"
'**    a=Getvalue("HKEY_CURRENT_USER\Software\HBSoft\PEdit\WindowSettings\frmPEdit","Left",Default)
'** 3. hier wird die PreKey-Einstellung verwendet und der Parameter
'**    stSection=""
'**    HKEY_CURRENT_USER\Software\hbsoft\PEdit\WindowSettings\frmPEdit
'**    a=Getvalue("","Left",Default)

Private m_Str As clsString

Private m_lError As Long
Private m_lRootClass As Long
Private m_stPreKey As String

Private Type FILETIME
  lLowDateTime    As Long
  lHighDateTime   As Long
End Type

Private Type SECURITYATTRIBUTES
  nLength As Long
  lpSecurityDescriptor As Long
  bInheritHandle As Boolean
End Type

Private Declare Function RegEnumKeyEx Lib "advapi32.dll" Alias "RegEnumKeyExA" (ByVal hKey&, ByVal dwIndex&, ByVal lpName$, lpcbName&, ByVal lpReserved&, ByVal lpClass$, lpcbClass&, lpftLastWriteTime As FILETIME) As Long
Private Declare Function RegQueryInfoKey Lib "advapi32.dll" Alias "RegQueryInfoKeyA" (ByVal hKey As Long, ByVal lpClass As String, lpcbClass As Long, ByVal lpReserved As Long, lpcSubKeys As Long, lpcbMaxSubKeyLen As Long, lpcbMaxClassLen As Long, lpcValues As Long, lpcbMaxValueNameLen As Long, lpcbMaxValueLen As Long, lpcbSecurityDescriptor As Long, lpftLastWriteTime As FILETIME) As Long
Private Declare Function RegCreateKeyEx Lib "advapi32.dll" Alias "RegCreateKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal Reserved As Long, ByVal lpClass As String, ByVal dwOptions As Long, ByVal samDesired As Long, lpSecurityAttributes As SECURITYATTRIBUTES, phkResult As Long, lpdwDisposition As Long) As Long
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function RegEnumValue Lib "advapi32.dll" Alias "RegEnumValueA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpValueName As String, lpcbValueName As Long, lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Private Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" (ByVal hKey As Long, ByVal lpSubKey As String) As Long
Private Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey As Long, ByVal lpValueName As String) As Long
Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Private Declare Function RegQueryValue Lib "advapi32.dll" Alias "RegQueryValueA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal lpValue As String, lpcbValue As Long) As Long
' Note that if you declare the lpData parameter as String, you must pass it By Value.
Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Private Declare Function RegSetValue Lib "advapi32.dll" Alias "RegSetValueA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal dwType As Long, ByVal lpData As String, ByVal cbData As Long) As Long
' Note that if you declare the lpData parameter as String, you must pass it By Value.
Private Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpData As Any, ByVal cbData As Long) As Long
Private Declare Function FormatMessage Lib "kernel32" Alias "FormatMessageA" (ByVal dwFlags As Long, lpSource As Any, ByVal dwMessageId As Long, ByVal dwLanguageId As Long, ByVal lpBuffer As String, ByVal nSize As Long, Arguments As Long) As Long

Private Const FORMAT_MESSAGE_FROM_SYSTEM = &H1000

Private Const READ_CONTROL = &H20000
Private Const STANDARD_RIGHTS_READ = READ_CONTROL
Private Const KEY_QUERY_VALUE = &H1
Private Const KEY_ENUMERATE_SUB_KEYS = &H8
Private Const KEY_NOTIFY = &H10
Private Const SYNCHRONIZE = &H100000
Private Const STANDARD_RIGHTS_ALL = &H1F0000
Private Const KEY_SET_VALUE = &H2
Private Const KEY_CREATE_SUB_KEY = &H4
Private Const KEY_CREATE_LINK = &H20
Private Const KEY_ALL_ACCESS = ((STANDARD_RIGHTS_ALL Or KEY_QUERY_VALUE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY Or KEY_CREATE_LINK) And (Not SYNCHRONIZE))
Private Const KEY_READ = ((STANDARD_RIGHTS_READ Or KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY) And (Not SYNCHRONIZE))

Private Const REG_NONE = 0                       ' No value type
Private Const REG_SZ = (1)                       'Zeichenkettenformat fr Nullwerte
Private Const REG_OPTION_NON_VOLATILE = 0        ' Key is preserved when system is rebooted
Private Const REG_DWORD = 4                      ' 32-bit number

Private Const ERROR_SUCCESS = 0&
Private Const ERROR_MORE_DATA = 234&
Private Const ERROR_NO_MORE_ITEMS = 259&

Private Const MODULNAME  As String = "clsRegistry"
Private m_Err As clsError


'************************************************************
'**
'** Beschreibung: stPreKey
'** Set/ermittelt die Voreinstellung eines Keys.
'** Voreinstelleung "HKEY_CLASSES_ROOT\Software"
'**
'** Rckgabe:           Key
'**
'** Datum/Author/Rechner
'** 15.09.97 RGrothaus MIT01
'**
'** Update/Author/Rechner
'** 02.03.98      Reinhard         WILLIE
'**
'************************************************************
Public Property Get stPreKey() As String
  stPreKey = m_stPreKey
End Property

Public Property Let stPreKey(ByVal New_stPreKey As String)
Attribute stPreKey.VB_Description = "Set/ermittelt die Voreinstellung eines Keys. Voreinstelleung ""HKEY_CLASSES_ROOT\\Software"" "
  If Len(New_stPreKey) Then
    m_lRootClass = GetRootkey(New_stPreKey)
    If Asc(Trim$(Right$(New_stPreKey, 1))) <> 92 Then
      m_stPreKey = New_stPreKey & "\"
    Else
      m_stPreKey = New_stPreKey
    End If
  Else
    m_stPreKey = ""
  End If
  
End Property

'************************************************************
'**
'** Beschreibung: GetRootkey
'** ermittelt den Rootkey des angegebenen Schlssels.
'**
'** Rckgabe:     RootKey-Handle
'**
'** Eingabe: stPreKey = KeyName
'**
'** Datum/Author/Rechner
'** 16.09.97 RGrothaus MIT01
'**
'** Update/Author/Rechner
'** 02.03.98      Reinhard         WILLIE
'**
'************************************************************
Private Function GetRootkey(stPreKey As String) As Long
Attribute GetRootkey.VB_Description = "ermittelt den Rootkey des angegebenen Schlssels. "
  If UCase$(Left$(stPreKey, 5)) = "HKEY_" Then
    Select Case UCase(m_Str.SplittStr(stPreKey, "\"))
    Case "HKEY_CLASSES_ROOT"
      GetRootkey = &H80000000
    Case "HKEY_CURRENT_USER"
      GetRootkey = &H80000001
    Case "HKEY_LOCAL_MACHINE"
      GetRootkey = &H80000002
    Case "HKEY_USERS"
      GetRootkey = &H80000003
    End Select
  Else
    GetRootkey = m_lRootClass
    If Len(m_stPreKey) And Len(stPreKey) Then
      If Asc(Right$(m_stPreKey, 1)) = 92 And Asc(Left$(stPreKey, 1)) = 92 Then
        stPreKey = m_stPreKey & Mid$(stPreKey, 2)
      ElseIf Asc(Right$(m_stPreKey, 1)) <> 92 And Asc(Left$(stPreKey, 1)) <> 92 Then
        stPreKey = m_stPreKey & "\" & stPreKey
      Else
        stPreKey = m_stPreKey & stPreKey
      End If
    Else
        stPreKey = m_stPreKey & stPreKey
    End If
  End If
End Function

'************************************************************
'**
'** Beschreibung: GetAllValues
'** Liest alle Eintrge unter 'stSection'. stSection ist
'** entweder der komplette Keyname inclusive 'HKEY_*' oder die
'** Fortsetzung von stPreKey. Beispiel Siehe Modul-Declaration.
'**
'** Rckgabe:   2 Dimensionales Variant-Array
'**           (0,Counter)=Key-Name, (1,Counter)=Wert
'**
'** Eingabe: stSection = Section, dessen Schlssel u. Werte
'**                      gelesen werden
'**
'** Datum/Author/Rechner
'** 16.09.97 RGrothaus MIT01
'**
'** Update/Author/Rechner
'** 02.03.98      Reinhard         WILLIE
'**
'************************************************************
Public Function GetAllValues(ByVal stSection As String) As Variant
Attribute GetAllValues.VB_Description = "Liest alle Eintrge unter 'stSection'. stSection ist entweder der komplette Keyname inclusive 'HKEY_*' oder die Fortsetzung von stPreKey. Beispiel Siehe Modul-Declaration. "
  Dim lResult As Long           'Ergebniss der API-Aufrufe
  Dim lergkey As Long           'Key-Handle
  Dim lDataType As Long         'Art der Daten(alle Konstanten, die mit 'reg_' anfangen)
  Dim iCounter As Integer       'Enumerations-Zhler
  Dim stKeyBuffer As String     'Puffer fr der Namen des Eintrags
  Dim lvaluelen As Long         'Grsse des Aufnahme-Puffers
  Dim lKeyBufferLen As Long     'Grsse des Key-Puffers
  Dim stValue As String         'Aufname der Werte
  Dim lValue As Long            'Aufname der Werte
  Dim iAusgabe As Integer       'Rckgabe-Feld-Counter
  Dim lRootKey As Long
  
  ReDim Ausgabe(1, 0) As Variant 'Rckgabe-Datenfeld,(0,iAusgabe)=Keyname,(1,iAusgabe)=Wert
    
    'Erster Eintrag enthlt den Standerd-Wert

  Ausgabe(1, iAusgabe) = GetStandard(stSection)
  Ausgabe(0, iAusgabe) = "(Standard)"
    
  lRootKey = GetRootkey(stSection)
  If lRootKey Then
    'Key ffnen
    lResult = RegOpenKeyEx(lRootKey, stSection, 0&, KEY_QUERY_VALUE, lergkey)
    If lResult = ERROR_SUCCESS Then
      'Puffer-Gre setzen
      lKeyBufferLen = 255
      stKeyBuffer = String(lKeyBufferLen + 1, 0)
      'Eintrge lesen
      Do While RegEnumValue(lergkey, iCounter, stKeyBuffer, lKeyBufferLen, ByVal 0&, REG_SZ, ByVal stValue, lvaluelen) <> ERROR_NO_MORE_ITEMS
        'Puffer-Gre anpassen
        stValue = String(lvaluelen + 1, 0)
        
        lKeyBufferLen = lKeyBufferLen + 1
        stKeyBuffer = String(lKeyBufferLen + 1, 0)
        'Eintrge lesen
        RegEnumValue lergkey, iCounter, stKeyBuffer, lKeyBufferLen, ByVal 0&, lDataType, ByVal stValue, lvaluelen
        ' nur wenn der DatenType=String Daten in das Ausgabe-Array bernehmen
        If lDataType = REG_SZ Then
          If lKeyBufferLen Then
            iAusgabe = iAusgabe + 1
            ReDim Preserve Ausgabe(1, iAusgabe)
            Ausgabe(0, iAusgabe) = Left$(stKeyBuffer, lKeyBufferLen)
            Ausgabe(1, iAusgabe) = Left$(stValue, lvaluelen - 1)
          End If
        End If
        iCounter = iCounter + 1
        lDataType = REG_NONE
        'Puffer-Gre auf Standardwert setzen
        lKeyBufferLen = 255
        stKeyBuffer = String(lKeyBufferLen + 1, 0)
      Loop
      'Key schlieen
    End If
    'Array als Rckgabe zuweisen
    m_lError = lResult
    lResult = RegCloseKey(lergkey)
  Else
    m_lError = 3
  End If
  If m_lError <> ERROR_SUCCESS Then
    ErrorHandler "GetAllValues : " & stSection
  Else
    GetAllValues = Ausgabe
  End If
End Function
'************************************************************
'**
'** Beschreibung: GetEnumKeys
'** gibt alle Unterschlssel der angegebenen Section zurxk
'**
'** Rckgabe: Variant-Array mit allen Unterschlsseln
'**
'** Realisierung /Author          /Rechner
'** 02.03.98      Reinhard         WILLIE
'**
'** Update       /Author          /Rechner
'**
'**
'************************************************************
Public Function GetEnumKeys(ByVal stSection As String) As Variant
Attribute GetEnumKeys.VB_Description = "gibt alle Unterschlsser der angegebenen Section zurxk"
  Dim lResult As Long         'Ergnissspeicher der API-Aufrufe
  Dim lergkey As Long         'geffneter Key
  Dim stSubKeyName As String   'Puffer fr der Namen des Eintrags
  Dim lSubKeyLen As Long
  Dim lRootKey As Long
  Dim lKeyIndx As Long
  Dim stClass As String
  Dim lClassLen As Long
  Dim lSubKeys As Long
  Dim lMaxSubKey As Long
  Dim lMaxClass As Long
  Dim lValues As Long
  Dim lMaxValueName As Long
  Dim lMaxValueData As Long
  Dim lSecurityDesc As Long
  Dim StrucLastWriteTime As FILETIME
  
  ReDim vRet(0) As Variant
  
  lClassLen = 255
  stClass = Space$(lClassLen)

  lRootKey = GetRootkey(stSection)
  GetEnumKeys = Empty
  
  If lRootKey Then
    lResult = RegOpenKeyEx(lRootKey, stSection, 0&, KEY_READ, lergkey)
    If lResult = ERROR_SUCCESS Then
      
      lResult = RegQueryInfoKey(lergkey, stClass, lClassLen, 0&, lSubKeys, lMaxSubKey, lMaxClass, lValues, lMaxValueName, lMaxValueData, lSecurityDesc, StrucLastWriteTime)
      If lResult = ERROR_SUCCESS Then
        stSubKeyName = Space$(lMaxSubKey + 1)
        lSubKeyLen = CLng(Len(stSubKeyName))
        stClass = Space$(lMaxClass + 1)
        lClassLen = CLng(Len(stClass))
    
        
        ' --------------------------------------------------
        ' Call the enumeration function
        ' --------------------------------------------------
        For lKeyIndx = 0 To lSubKeys - 1
          lResult = RegEnumKeyEx(lergkey, lKeyIndx, stSubKeyName, lSubKeyLen, 0&, stClass, lClassLen, StrucLastWriteTime)
          If lResult = 0 Then
            ReDim Preserve vRet(lKeyIndx)
            vRet(lKeyIndx) = Left$(stSubKeyName, lSubKeyLen)
            
          End If
          
          stSubKeyName = Space$(lMaxSubKey + 1)
          lSubKeyLen = CLng(Len(stSubKeyName))
          stClass = Space$(lMaxClass + 1)
          lClassLen = CLng(Len(stClass))
          
        Next
        If lSubKeys Then GetEnumKeys = vRet
      End If
 
    End If
    
  End If
End Function
'************************************************************
'**
'** Beschreibung: GetValue
'** Ermittelt der Wert von stkey in Section stSection
'**
'** Rckgabe:   Wenn kein Fehler wird der Wert, ansonsten der
'**                   angegebene Defaultwert zurck.
'**
'** Eingabe: stSection = Section des Schlssels
'**          stKey     = Key, dessen  Wert gelesen wird
'**          stDefault = Voreinstellung fr Wert, wird
'**                      zurckgegeben, wenn der Key nicht
'**                      existiert
'**
'** Datum/Author/Rechner
'** 16.09.97 RGrothaus MIT01
'**
'** Update/Author/Rechner
'** 02.03.98      Reinhard         WILLIE
'**
'************************************************************
Public Function GetValue(ByVal stSection As String, ByVal stkey As String, Optional ByVal stDefault As String) As String
Attribute GetValue.VB_Description = "Ermittelt der Wert von stkey in Section stSection "
  Dim lResult As Long         'Ergnissspeicher der API-Aufrufe
  Dim lergkey As Long         'geffneter Key
  Dim lDataType As Long       'Art der Daten(alle constanten, die mit 'reg_' anfangen)
  Dim stKeyBuffer As String   'Puffer fr der Namen des Eintrags
  Dim lvaluelen As Long       'Grsse des Aufnahme-Puffers
  Dim stValue As String       'Aufname der Werte
  Dim lValue As Long          'Aufname der Werte
  Dim bytValue() As Byte      'Aufname der Werte
  Dim vBack() As Variant
  Dim iCounter As Integer
  Dim stKeyName As String
  Dim lRootKey As Long
  
  lRootKey = GetRootkey(stSection)
  If lRootKey Then
    
    lResult = RegOpenKeyEx(m_lRootClass, stSection, 0&, KEY_QUERY_VALUE, lergkey)
    If lResult = ERROR_SUCCESS Then
      stKeyBuffer = String(256, vbNullChar)
      stValue = String(256, 0)
      lvaluelen = 256
      lResult = RegQueryValueEx(lergkey, stkey, ByVal 0&, lDataType, ByVal stValue, lvaluelen)
      If lResult = ERROR_SUCCESS Then
        If lDataType = REG_SZ Then
          GetValue = Left$(stValue, InStr(stValue, vbNullChar) - 1)
        ElseIf lDataType = REG_DWORD Then
         lResult = RegQueryValueEx(lergkey, stkey, ByVal 0&, lDataType, lValue, lvaluelen)
          GetValue = lValue
        End If
      ElseIf lResult = ERROR_MORE_DATA Then ' stValue zu Kurz, Grsse anpassen und nochmal Lesen
        stValue = String(lvaluelen + 1, 0)
        lResult = RegQueryValueEx(lergkey, stkey, ByVal 0&, lDataType, ByVal stValue, lvaluelen)
        If lDataType = REG_SZ Then GetValue = Left$(stValue, InStr(stValue, vbNullChar) - 1)
      End If
      
    End If
    m_lError = lResult
    lResult = RegCloseKey(lergkey)
  Else
    m_lError = 3
    
  End If
  
  If m_lError <> ERROR_SUCCESS And m_lError <> 2 Then
    ErrorHandler "GetValue"
  End If
  
  If m_lError <> ERROR_SUCCESS Then
    GetValue = stDefault
  End If
End Function

'************************************************************
'**
'** Beschreibung: SetValue
'** Setzt den Wert von stkey in Section stSection
'**
'** Eingabe: stKey     = Key, dessen  Wert gelesen wird
'**          stValue   = Wert, der gesetzt wird
'**
'** Datum/Author/Rechner
'** 16.09.97 RGrothaus MIT01
'**
'** Update/Author/Rechner
'** 02.03.98      Reinhard         WILLIE
'**
'************************************************************
Public Sub SetValue(ByVal stKeyName As String, ByVal stkey As String, ByVal stValue As String)
Attribute SetValue.VB_Description = "Setzt den Wert von stkey in Section stSection "
  Dim lResult As Long         'Ergnissspeicher der API-Aufrufe
  Dim lergkey As Long         'geffneter Key
  Dim lHasCreatet As Long
  Dim SA As SECURITYATTRIBUTES
  Dim lRootKey As Long
  
  lRootKey = GetRootkey(stKeyName)
  If lRootKey Then
    lResult = RegCreateKeyEx(lRootKey, stKeyName, 0&, stkey, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, SA, lergkey, lHasCreatet)
    If lResult = ERROR_SUCCESS Then
      If Len(stValue) Then
        lResult = RegSetValueEx(lergkey, stkey, 0&, REG_SZ, ByVal stValue, Len(stValue))
      End If
    End If
    m_lError = lResult
    lResult = RegCloseKey(lergkey)
  Else
    m_lError = 3
  End If
  If m_lError <> ERROR_SUCCESS Then ErrorHandler "SetValue"
End Sub

'************************************************************
'**
'** Beschreibung: DelValue
'** Lscht einen Key(wenn stKey angegeben) oder die Section
'** stSection
'**
'** Eingabe: stSection = Section, die gelscht wird, wenn Key =
'**                      nichts
'**          stKey     = Key, der gelscht wird oder nichts
'**
'** Datum/Author/Rechner
'** 16.09.97 RGrothaus MIT01
'**
'** Update/Author/Rechner
'** 02.03.98      Reinhard         WILLIE
'**
'************************************************************
Public Sub DelValue(ByVal stSection As String, Optional stkey As String)
Attribute DelValue.VB_Description = "Lscht einen Key(wenn stKey angegeben) oder die Section stSection "
  Dim lResult As Long
  Dim lergkey As Long
  Dim lRootKey As Long
  
  lRootKey = GetRootkey(stSection)
  If lRootKey Then
    If Len(stkey) Then
      lResult = RegOpenKeyEx(m_lRootClass, stSection, 0&, KEY_SET_VALUE, lergkey)
      lResult = RegDeleteValue(lergkey, stkey)
      RegCloseKey lergkey
    Else
      lResult = RegDeleteKey(m_lRootClass, stSection)
    End If
    m_lError = lResult
  Else
    m_lError = 3
  End If
  If m_lError <> ERROR_SUCCESS Then ErrorHandler "DelValue : " & stSection
End Sub

'************************************************************
'**
'** Beschreibung: GetStandard
'** Ermittelt der Standard-Wert von stSection
'**
'** Rckgabe:   Standardwert
'**
'** Eingabe: stSection = Section des Schlssels
'**          stDefault = Voreinstellung fr Wert, wird
'**                      zurckgegeben, wenn der Key nicht
'**                      existiert
'**
'** Datum/Author/Rechner
'** 16.09.97 RGrothaus MIT01
'**
'** Update/Author/Rechner
'** 02.03.98      Reinhard         WILLIE
'**
'************************************************************
Public Function GetStandard(ByVal stSection As String, Optional ByVal stDefault As String) As String
Attribute GetStandard.VB_Description = "Ermittelt der Standard-Wert von stSection "
  Dim lvaluelen As Long 'Grsse des Aufnahme-Puffers
  Dim stValue As String 'Aufname des Wertes
  Dim lResult As Long   'Ergebniss der API-Aufrufe
  Dim lergkey As Long   'Key-Handle
  Dim lRootKey As Long
  
  lRootKey = GetRootkey(stSection)
  If lRootKey Then
    lvaluelen = 255
    stValue = String(lvaluelen + 1, 0)
    'Key ffnen
    lResult = RegOpenKeyEx(lRootKey, stSection, 0&, KEY_QUERY_VALUE, lergkey)
    
    If lResult = ERROR_SUCCESS Then 'Wenn kein Fehler
      'Eintrag lesen
      lResult = RegQueryValue(lergkey, "", stValue, lvaluelen)
      If lResult = ERROR_MORE_DATA Then ' stValue zu Kurz, Grsse anpassen und nochmal Lesen
        stValue = String(lvaluelen + 1, 0)
        lResult = RegQueryValue(lergkey, "", stValue, lvaluelen)
      End If
      'Ergebniss zuweisen
      GetStandard = IIf(Len(Left$(stValue, InStr(stValue, vbNullChar) - 1)), Left$(stValue, InStr(stValue, vbNullChar) - 1), stDefault)
    End If
    m_lError = lResult
    lResult = RegCloseKey(lergkey)
  End If
  
  If m_lError <> ERROR_SUCCESS And m_lError <> 2 Then
    ErrorHandler "GetValue"
  End If
  
  If m_lError <> ERROR_SUCCESS Then
    GetStandard = stDefault
  End If

End Function

'************************************************************
'**
'** Beschreibung: SetStandard
'** Setzt den Standard-Wert von stSection
'**
'** Eingabe: stSection = Section des Schlssels
'**          stValue   = Wert, der gesetzt wird
'**
'** Datum/Author/Rechner
'** 16.09.97 RGrothaus MIT01
'**
'** Update/Author/Rechner
'** 02.03.98      Reinhard         WILLIE
'**
'************************************************************
Public Sub SetStandard(ByVal stSection As String, ByVal stValue As String)
Attribute SetStandard.VB_Description = "Setzt den Standard-Wert von stSection "
  Dim lResult As Long         'Ergnissspeicher der API-Aufrufe
  Dim lergkey As Long         'geffneter Key
  Dim lDataType As Long       'Art der Daten(alle constanten, die mit 'reg_' anfangen)
  Dim stKeyBuffer As String   'Puffer fr der Namen des Eintrags
  Dim lvaluelen As Long       'Grsse des Aufnahme-Puffers
  Dim lRootKey As Long
  Dim lHasCreatet As Long
  Dim SA As SECURITYATTRIBUTES
  
  lRootKey = GetRootkey("")
  If lRootKey Then
    lResult = RegCreateKeyEx(lRootKey, m_stPreKey & stSection, 0&, stSection, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, SA, lergkey, lHasCreatet)
    If lResult = ERROR_SUCCESS Then
      If Len(stValue) Then
        lResult = RegSetValue(lergkey, "", REG_SZ, ByVal stValue, Len(stValue))
      Else
        lResult = RegDeleteValue(lergkey, "")
      End If
    End If
    m_lError = lResult
    lResult = RegCloseKey(lergkey)
  Else
    m_lError = 3
  End If
  If m_lError <> ERROR_SUCCESS Then ErrorHandler "SetStandard"
End Sub

'************************************************************
'**
'** Beschreibung: DelStandard
'** Lscht einen Standardwert von stSection
'**
'** Eingabe: stSection = Section, die gelscht wird, wenn Key =
'**                      nichts
'**
'** Datum/Author/Rechner
'** 16.09.97 RGrothaus MIT01
'**
'** Update/Author/Rechner
'** 02.03.98      Reinhard         WILLIE
'**
'************************************************************
Public Sub DelStandard(ByVal stSection As String)
Attribute DelStandard.VB_Description = "Lscht einen Standardwert von stSection "
  Dim lResult As Long
  Dim lergkey As Long
  Dim lRootKey As Long
  
  lRootKey = GetRootkey(stSection)
  If lRootKey Then
    lResult = RegOpenKeyEx(lRootKey, stSection, 0&, KEY_SET_VALUE, lergkey)
    lResult = RegDeleteValue(lergkey, "")
    RegCloseKey lergkey
    m_lError = lResult
  Else
    m_lError = 3
  End If
  If m_lError <> ERROR_SUCCESS Then ErrorHandler "DelStandard : " & stSection
End Sub


'************************************************************
'**
'** Beschreibung: ErrorHandler
'** Gibt die System-Fehlermeldung bei API-Fehlern zurck
'**
'** Eingabe: ProcedurName = Name des Aufrufers
'**
'** Datum/Author/Rechner
'** 20.09.97 RGrothaus MIT01
'**
'** Update/Author/Rechner
'** 02.03.98      Reinhard         WILLIE
'**
'************************************************************
Private Sub ErrorHandler(ProcedurName As String)
Attribute ErrorHandler.VB_Description = "Gibt die System-Fehlermeldung bei API-Fehlern zurck "
  Dim lResult As Long
  Dim lMsg As Long
  Dim stMsg As String
  
  If m_lError Then
    lMsg = 255
    stMsg = String(lMsg, 0)
    lResult = FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, 0, m_lError, 0&, stMsg, lMsg, 0)
    Err.Number = m_lError
    Err.Description = Left(stMsg, lResult)
    Call m_Err.WriteLogShow(Err, MODULNAME, ProcedurName)
  End If
End Sub

Private Sub Class_Initialize()
     'ClsError initialisieren
  Set m_Str = New clsString
  m_stPreKey = "Software"
  m_lRootClass = &H80000001 'HKEY_CURRENT_USER
End Sub

Friend Property Set Error(New_Error As clsError)
  Set m_Err = New_Error
End Property

